//
//  GameObject.h
//  Boise_Demo
//
//  Created by Jared Halpern on 3/3/12.
//  Copyright 2012 __MyCompanyName__. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "cocos2d.h"
#import "Constants.h"
#import "CommonProtocols.h"
//#import "GameManager.h"


@interface GameObject : CCSprite {
    
    GameObjectType gameObjectType;
    ObjectStates objectState;
    id <GameplayLayerDelegate> delegate;
    
    BOOL isAlive;
    
    CCLabelBMFont *statusLabel;
    double timeRemaining;
    NSString *timeElapsedString;
    double timeStart;
}

@property (readwrite) GameObjectType gameObjectType;
@property (nonatomic, assign) CCLabelBMFont *statusLabel;
@property (readwrite) BOOL isAlive;
@property (readwrite) ObjectStates objectState;
@property (nonatomic, assign) id <GameplayLayerDelegate> delegate;

-(void)changeState:(ObjectStates)newState;
-(void)checkAndClampSpritePosition;
-(CGRect)adjustedBoundingBox; // adjust to size of sprite w/o transparent space
-(void)updateStateWithDeltaTime:(ccTime)deltaTime andListOfGameObjects:(CCArray *)gameObjects;
-(CCAnimation*)loadPlistForAnimationWithName:(NSString*)animationName andClassName:(NSString*)className;

@end
