//
//  GameScene.m
//  Boise_Demo
//
//  Created by Jared Halpern on 3/2/12.
//  Copyright 2012 __MyCompanyName__. All rights reserved.
//

#import "GameScene.h"


@implementation GameScene

//@synthesize world;
//@synthesize gameSceneSpriteBatchNode;


-(void)setupBox2DWorld{
    
    // create gravity vector
    b2Vec2 gravity = b2Vec2(0.0f, 0.0f);
    
    // objects will sleep when at rest
    bool doSleep = true;
    
    // create the world on the stack
    world = new b2World(gravity, doSleep);
}


-(void)setupDebugDraw{
    
    // multiply by PTM_RATIO bc GLESDebugDraw does pixels, not points.
    debugDraw = new GLESDebugDraw(PTM_RATIO * [[CCDirector sharedDirector] contentScaleFactor]);
    
    world->SetDebugDraw(debugDraw);
    debugDraw->SetFlags(b2DebugDraw::e_shapeBit);
}


-(void)dealloc{

    if (world) {
        delete world;
        world = NULL;
    }
    
    [super dealloc];
}

-(id)init{
    
    self = [super init];
    if (self != nil) {
        
//        [self setupBox2DWorld];
//        [self setupDebugDraw];
        
        [[CCSpriteFrameCache sharedSpriteFrameCache] addSpriteFramesWithFile:@"MasterSpriteAtlas.plist"];
        gameSceneSpriteBatchNode = [CCSpriteBatchNode batchNodeWithFile:@"MasterSpriteAtlas.png"];
        
        BackgroundLayer *backgroundLayer = [BackgroundLayer node];
        [self addChild:backgroundLayer z:0 tag:kLayerTagBackground];
        
        GameplayLayer *gameplayLayer = [GameplayLayer node];
        [self addChild:gameplayLayer z:1 tag:kLayerTagGameplay];
        
    }
    
    return self;
}



-(void)update:(ccTime)deltaTime{
    
    CCLOG(@"gamescene...");    
}


@end
