//
//  GameplayLayer.m
//  Boise_Demo
//
//  Created by Jared Halpern on 3/2/12.
//  Copyright 2012 __MyCompanyName__. All rights reserved.
//

#import "GameplayLayer.h"


@implementation GameplayLayer

//@synthesize world;

@synthesize fireEmitter;
@synthesize smokeEmitter;

# pragma -
# pragma mark Touch Stuff

-(void)registerWithTouchDispatcher{
    
    [[CCTouchDispatcher sharedDispatcher] addTargetedDelegate:self priority:0 swallowsTouches:YES];
}

-(BOOL) ccTouchBegan:(UITouch *)touch withEvent:(UIEvent *)event{
    
    return YES;
}

-(void) ccTouchMoved:(UITouch *)touch withEvent:(UIEvent *)event{
    
}

-(void)ccTouchEnded:(UITouch *)touch withEvent:(UIEvent *)event{
    
    CGPoint touchLocation = [touch locationInView: [touch view]];		
    touchLocation = [[CCDirector sharedDirector] convertToGL: touchLocation];
    touchLocation = [self convertToNodeSpace:touchLocation];
    
    [self setDogPlayerPosition:touchLocation];
}

-(void)setDogPlayerPosition:(CGPoint)newPosition{
    
    CGPoint previousPosition = [self position];
    float previousAngle = [self rotation]; // in degrees

    // positive angles rotate node clockwise
    // determine offset to new location
    float offsetX = newPosition.x - previousPosition.x;
    float offsetY = newPosition.y - previousPosition.y;
    
    NSLog(@"newPosition.x: %f - previousPosition.x: %f", newPosition.x, previousPosition.x);
    NSLog(@"newPosition.y: %f - previousPosition.y: %f", newPosition.y, previousPosition.y);
    
    float angleRadians= atanf((float32)offsetY / (float32)offsetX);    
    float angleDegrees = CC_RADIANS_TO_DEGREES(angleRadians);
    float newAngle = angleDegrees;
    
    CCLOG(@"angle: %g degrees", newAngle);
    //[playerObject setRotation:newAngle];
    
    id actionRotate = [CCRotateBy actionWithDuration:.1 angle:newAngle];
    [playerObject runAction:actionRotate];

    
/**    
    int realX = [[CCDirector sharedDirector] winSize].width - [playerObject contentSize].width/2; 
//    int realY = [[CCDirector sharedDirector] winSize].height + [playerObject contentSize].height/2;     
    
    float ratio = (float) offsetY / (float) offsetX;
    int realY = (realX * ratio) + previousPosition.y;
    CGPoint realDest = ccp(realX, realY);
    
    // Determine the length of how far we're shooting
    int offRealX = realX - previousPosition.x;
    int offRealY = realY - previousPosition.y;
    
    // get hypotenuse
    float length = sqrtf((offRealX*offRealX)+(offRealY*offRealY));
    float velocity = 480/1; // 480pixels/1sec
    float realMoveDuration = length/velocity;    
    
    // determine angle to face
    float angleRadians = atanf((float32) offRealY / (float32) offRealX);
    
    float angleOffset = CC_DEGREES_TO_RADIANS(180);
    CGPoint diff = ccpSub(previousPosition, newPosition);
    
    if (diff.x < 0)
        angleRadians += angleOffset;
    else
        angleRadians -= angleOffset;
    
    float angleDegrees = CC_RADIANS_TO_DEGREES(angleRadians);
    float newAngle = -1 * angleDegrees;
    //playerObject.rotation = newAngle;

    id actionRotate = [CCRotateBy actionWithDuration:.1 angle:newAngle];
    [playerObject runAction:actionRotate];
    // change state (which changes animation)

 **/

    // move dog player
    id actionMove = [CCMoveTo actionWithDuration:2.0 position:newPosition];
    
//    id actionMoveDone = [CCCallFunc actionWithTarget:playerObject selector:@selector(dogPlayerIdle)];
//    [playerObject runAction:[CCSequence actions:actionMove, actionMoveDone, nil]];
    
    [playerObject runAction:actionMove];

    
}

-(void)dogPlayerIdle{
    
    // dog animation will change to idle if player does nothing for too long
    // take timestamp when first becoming idle
    // after 10 seconds, change state
    
}


# pragma mark -
#pragma mark Setup

-(void)resetLevel{
    
    //reset Box2D world and objects
    
    CCLOG(@"Reset Level");
    
    for(b2Body *b = world->GetBodyList(); b; b=b->GetNext()){
        
        // perhaps replace with assert?
        if(b->GetUserData() != NULL){
            
            GameObject *tempGameObj = (GameObject *) b->GetUserData();
            
            //if([tempGameObj getObjType] == kEnemyObj)
            [tempGameObj changeState:kStateDead];
        }
    } // for

}

-(void)setupLevel{
    
    /*******************/
    // START label
    CCLabelBMFont *startLabel = [CCLabelBMFont labelWithString:@"Start!!" fntFile:@"BoiseMediumFont.fnt"];
    [startLabel setPosition:ccp(screenSize.width *.5, screenSize.height*.75)];
    [self addChild:startLabel];
    
    id startLabelAction = [CCSpawn actions:
                           [CCScaleBy actionWithDuration:3.0f scale:4],
                           [CCFadeOut actionWithDuration:2.0f], nil];
    
   [startLabel runAction:startLabelAction];    

    CCLabelBMFont *escapeLabel = [CCLabelBMFont labelWithString:@"ESCAPE FROM THE\nEVIL SCIENTISTS\nLAB!!" fntFile:@"BoiseMediumFont.fnt"];
    [escapeLabel setPosition:ccp(screenSize.width /2, screenSize.height /2)];
    [self addChild:escapeLabel];
    
    id escapeLabelAction = [CCSpawn actions:
                           [CCScaleBy actionWithDuration:8.0f scale:2],
                           [CCFadeOut actionWithDuration:4.0f], nil];
    
    [escapeLabel runAction:escapeLabelAction];   
    
    /*******************/
    // Health bar 
    tempHealthBar = [CCProgressTimer progressWithFile:@"healthbar.png"];
    [tempHealthBar setType: kCCProgressTimerTypeHorizontalBarRL];
    [tempHealthBar setPercentage:100];
    [tempHealthBar setPosition:ccp(screenSize.width - [tempHealthBar contentSize].width, 
                                   screenSize.height - [tempHealthBar contentSize].height)];
    [self addChild:tempHealthBar];
    
    /*******************/        
    
    // create exit
    
    // set up hedges
    
}

-(void)gameOver{    
    
    CCLabelBMFont *gameoverLabel = [CCLabelBMFont labelWithString:@"GAME OVER!" fntFile:@"BoiseMediumFont.fnt"];
    [gameoverLabel setPosition:ccp(screenSize.width /2, screenSize.height /2)];
    [self addChild:gameoverLabel];
    
    id gameoverLabelAction = [CCSpawn actions:
                           [CCScaleBy actionWithDuration:3.0f scale:4],
                           [CCFadeOut actionWithDuration:3.0f], nil];
    
    [gameoverLabel runAction:gameoverLabelAction];                

    
    
}

-(void)createPowerup{
    
    PowerupObject *powerupObject = [[PowerupObject alloc] initWithSpriteFrame:[[CCSpriteFrameCache sharedSpriteFrameCache] 
                                                                               spriteFrameByName:@"orb_01.png"]];

    CGPoint randomLocation = CGPointMake(CCRANDOM_0_1() * screenSize.height, 
                                         CCRANDOM_0_1() * screenSize.width);
    
    // ensure that the randomly placed powerup is not overlaping the edge of the screen
    // eventually move this code out of here place in the object so an object keeps track of its own
    // location and doesnt appear offscreen.
    if(randomLocation.x > (screenSize.width - ([powerupObject contentSize].width/2)))
        randomLocation.x = (screenSize.width - ([powerupObject contentSize].width/2));
    
    if(randomLocation.x < ([powerupObject contentSize].width/2))
        randomLocation.x = [powerupObject contentSize].width/2;
    
    if (randomLocation.y > (screenSize.height - ([powerupObject contentSize].height/2)))
        randomLocation.y = (screenSize.height - ([powerupObject contentSize].height/2));
    
    if(randomLocation.y < ([powerupObject contentSize].height/2))
        randomLocation.y = [powerupObject contentSize].height/2;
    
    // set randomized position
    [powerupObject setPosition:randomLocation];  
    
    // powerups will instruct this layer to update the healthbar and playerhealth percentage
    [powerupObject setDelegate:self];
    
    /***********************/
    // Box2D stuff
    
    // use Sensors here for collision detection but no response
    CGSize sensorSize =  CGSizeMake(powerupObject.contentSize.width/1.5, 
                                    powerupObject.contentSize.height/1.5);
    
    b2BodyDef bodyDef;
    bodyDef.type = b2_dynamicBody;
    
    bodyDef.position = b2Vec2((powerupObject.position.x)/PTM_RATIO, (powerupObject.position.y)/PTM_RATIO);
    
    // create a sensor
    b2Body *sensorBody = world->CreateBody(&bodyDef);
    
    // use sprite reference in the update method
    sensorBody->SetUserData(powerupObject);
    powerupObject.body = sensorBody;
    
    b2PolygonShape shape;
    
    shape.SetAsBox(sensorSize.width/2/PTM_RATIO, sensorSize.height/2/PTM_RATIO);
    
    b2FixtureDef fixtureDef;
    fixtureDef.shape  = &shape;
    fixtureDef.isSensor = TRUE;
    sensorBody->CreateFixture(&fixtureDef);
    
    // add to batch node for more efficent rendering
    [gameSceneSpriteBatchNode addChild:powerupObject z:1];

    // release bc gameSceneBatchNode contains reference
    //[powerupObject release];
    
    CCLOG(@"Creating Powerup.");
}

-(void)createRandomEnemy{
    
    
    EnemyObject *enemyObject = [[EnemyObject alloc] initWithSpriteFrame:[[CCSpriteFrameCache sharedSpriteFrameCache] 
                                                                               spriteFrameByName:@"slug_11.png"]];
    
    // create a little bit off screen
    //CGPoint randomLocation = CGPointMake(CCRANDOM_0_1() * screenSize.height, screenSize.width - [enemyObject contentSize].width);
    
    CGPoint randomLocation = CGPointMake(CCRANDOM_0_1() *screenSize.height, screenSize.width/2);
    
    // set randomized position
    [enemyObject setPosition:randomLocation]; 
    [enemyObject changeState:kStateRunEast];
    
    // powerups will instruct this layer to update the healthbar and playerhealth percentage
    [enemyObject setDelegate:self];
    
    /***********************/
    // Box2D stuff
    
    // use Sensors here for collision detection but no response
    CGSize sensorSize =  CGSizeMake(enemyObject.contentSize.width/1.5, 
                                    enemyObject.contentSize.height/1.5);
    
    b2BodyDef bodyDef;
    bodyDef.type = b2_dynamicBody;
    
    bodyDef.position = b2Vec2((enemyObject.position.x)/PTM_RATIO, (enemyObject.position.y)/PTM_RATIO);
    
    // create a sensor
    b2Body *sensorBody = world->CreateBody(&bodyDef);
    
    // use sprite reference in the update method
    sensorBody->SetUserData(enemyObject);
    enemyObject.body = sensorBody;
    
    b2PolygonShape shape;
    
    shape.SetAsBox(sensorSize.width/2/PTM_RATIO, sensorSize.height/2/PTM_RATIO);
    
    b2FixtureDef fixtureDef;
    fixtureDef.shape  = &shape;
    fixtureDef.isSensor = TRUE;
    sensorBody->CreateFixture(&fixtureDef);
    
    // add to batch node for more efficent rendering
    [gameSceneSpriteBatchNode addChild:enemyObject z:1];

    // enemyObject will be autoreleased
    
    id actionMove = [CCMoveTo actionWithDuration:20.0 position:ccp(screenSize.width, [enemyObject position].y)];
    [enemyObject runAction:actionMove];
    
    CCLOG(@"Creating Enemy.");
    
}

-(void)createPlayer{
    
    playerObject = [[DogPlayerObject alloc] initWithSpriteFrame:
                    [[CCSpriteFrameCache sharedSpriteFrameCache] 
                     spriteFrameByName:@"red-dog_01.png"]];
    
    CGPoint newPosition = ccp(screenSize.width/2, screenSize.height/2);
    
    [playerObject setPosition:newPosition];
    [playerObject setIsAlive:YES];
    [playerObject changeState:kStateRunNorth];

    // Box2D
    
    // use Sensors here for collision detection but no response
    CGSize sensorSize =  CGSizeMake(playerObject.contentSize.width/1.5, playerObject.contentSize.height/1.5);
    
    b2BodyDef bodyDef;
    bodyDef.type = b2_dynamicBody;
    bodyDef.position = b2Vec2((playerObject.position.x)/PTM_RATIO, (playerObject.position.y)/PTM_RATIO);
    bodyDef.allowSleep = FALSE;
    
    playerBody = world->CreateBody(&bodyDef);
    playerBody->SetUserData(playerObject);     // use sprite reference in the update method
    playerObject.body = playerBody;
    
    b2PolygonShape shape;
    shape.SetAsBox(sensorSize.width/2/PTM_RATIO, sensorSize.height/2/PTM_RATIO);
    
    b2FixtureDef fixtureDef;
    fixtureDef.shape  = &shape;
    fixtureDef.isSensor = TRUE;
    playerBody->CreateFixture(&fixtureDef);
    
    [gameSceneSpriteBatchNode addChild:playerObject z:50 tag:kPlayerTag];
    
}

-(void)createSmallFires{
    fireEmitter = [[CCParticleFire alloc] init];
    
    CGPoint randomLocation = CGPointMake(CCRANDOM_0_1() * screenSize.height, CCRANDOM_0_1() * screenSize.width);
    
    [fireEmitter setPosition:randomLocation];
//    [fireEmitter setPosition:ccp(screenSize.width/2, screenSize.height/2)];
    [fireEmitter setScaleX:0.2];
    [fireEmitter setScaleY:0.3];
    [fireEmitter setGravity:ccp(0,1)];
    [fireEmitter setDuration:1.0];
    
    [self addChild:fireEmitter z:1];
    
    smokeEmitter = [[CCParticleSmoke alloc] init];
    
//    CGPoint randomLocation = CGPointMake(CCRANDOM_0_1() * screenSize.height, CCRANDOM_0_1() * screenSize.width);
    
    [smokeEmitter setPosition:randomLocation];
    //    [smokeEmitter setPosition:ccp(screenSize.width/2, screenSize.height/2)];
    [smokeEmitter setScaleX:0.2];
    [smokeEmitter setScaleY:0.2];
    [smokeEmitter setGravity:ccp(0,4)];
    [smokeEmitter setDuration:4.0];
    
    [self addChild:smokeEmitter z:0];

}


-(void)startMusic{
    
//    [[SimpleAudioEngine sharedEngine] preloadBackgroundMusic:@"Internationale.mp3"];
    [[SimpleAudioEngine sharedEngine] playBackgroundMusic:@"Internationale.mp3" loop:YES];
}

-(void)dealloc{
        
    if (world) {
        delete world;
        world = NULL;
    }
    
    if (debugDraw){
        delete debugDraw;
        debugDraw = nil;
    }
    
    [fireEmitter release];
    [smokeEmitter release];
    [playerObject release];
    
    [super dealloc];    
}

-(id)init{
    
    self = [super init];
    if (self != nil){
        
        screenSize = [CCDirector sharedDirector].winSize;
                
        self.isTouchEnabled = YES;
        
        srandom(time(NULL));
        
        [[CCSpriteFrameCache sharedSpriteFrameCache] addSpriteFramesWithFile:@"MasterSpriteAtlas.plist"];
        gameSceneSpriteBatchNode = [CCSpriteBatchNode batchNodeWithFile:@"MasterSpriteAtlas.png"];
        
        [self addChild:gameSceneSpriteBatchNode z:2];
        
        
//        GameScene *tempScene = (GameScene *)[self parent];
//        world = (b2World *)[tempScene world];
        
        [self setupBox2DWorld]; // set up gravity, create world
        [self setupDebugDraw]; // only run while debugging; Box2D
        
        [self setupLevel]; // HUD-related stuff: labels, healthbar, no box2d stuff
        
        [self createPlayer];

        [self createRandomEnemy]; // add later
        [self startMusic]; // add later

        [self createPowerup];
        [self schedule:@selector(createPowerup) interval:5.0f];        
        
//        BackgroundLayer *backgroundLayer = (BackgroundLayer *)[self.parent getChildByTag:kLayerTagBackground];
//        [backgroundLayer test];        
        
//        [backgroundLayer schedule:@selector(test) interval:2.0f];
        
        // play music
        // play laughing sound effect
        
        [self schedule:@selector(createSmallFires) interval:6.0f];
//        [self createSmoke];
        
        [self scheduleUpdate];
    }
    return self;
}

#pragma mark -
#pragma mark Box2D

-(void)setupDebugDraw{
    
    // multiply by PTM_RATIO bc GLESDebugDraw does pixels, not points.
    debugDraw = new GLESDebugDraw(PTM_RATIO * [[CCDirector sharedDirector] contentScaleFactor]);
    
    world->SetDebugDraw(debugDraw);
    debugDraw->SetFlags(b2DebugDraw::e_shapeBit); // we want to draw shapes
}


-(void)setupBox2DWorld{
    
    // create gravity vector
    b2Vec2 gravity = b2Vec2(0.0f, 0.0f);
    
    // objects will sleep when at rest
    bool doSleep = true;

    // use Box2D world created in GameScene
//    GameScene *tempScene = (GameScene *)[self parent];
//    world = (b2World *)[tempScene world];

    world = new b2World(gravity, doSleep);
}

-(void)createGround{
    // not using anymore
    
    CGSize winSize = [[CCDirector sharedDirector] winSize];
    float32 margin = 10.0f;
    b2Vec2 lowerLeft = b2Vec2(margin/PTM_RATIO, margin/PTM_RATIO);
    b2Vec2 lowerRight = b2Vec2((winSize.width - margin)/PTM_RATIO, margin/PTM_RATIO);
    b2Vec2 upperRight = b2Vec2((winSize.width - margin)/PTM_RATIO, (winSize.height - margin)/PTM_RATIO);
    b2Vec2 upperLeft = b2Vec2(margin/PTM_RATIO, (winSize.height-margin)/PTM_RATIO);
    
    b2BodyDef groundBodyDef;
    groundBodyDef.type = b2_staticBody;
    groundBodyDef.position.Set(0,0);
    groundBody = world->CreateBody(&groundBodyDef);
    
    b2PolygonShape groundShape;
    b2FixtureDef groundFixtureDef;
    groundFixtureDef.shape = &groundShape;
    groundFixtureDef.density = 0.0;
    
    groundShape.SetAsEdge(lowerLeft, lowerRight);
    groundBody->CreateFixture(&groundFixtureDef);
    
    groundShape.SetAsEdge(lowerRight, upperRight);
    groundBody->CreateFixture(&groundFixtureDef);
    
    groundShape.SetAsEdge(upperRight, upperLeft);
    groundBody->CreateFixture(&groundFixtureDef);
    
    groundShape.SetAsEdge(upperLeft, lowerLeft);
    groundBody->CreateFixture(&groundFixtureDef);
    
}


# pragma mark -
# pragma mark Game Loop

-(void)update:(ccTime)deltaTime{
    
    CCArray *listGameObjects = [gameSceneSpriteBatchNode children];
    
    for (GameObject *tempChar in listGameObjects) {
        
        [tempChar updateStateWithDeltaTime:deltaTime andListOfGameObjects:listGameObjects];
    }
    
    // Box2D Stuff
    int32 velocityIterations = 3;
    int32 positionIterations = 2;
    world->Step(deltaTime, velocityIterations, positionIterations);

    for(b2Body *b = world->GetBodyList(); b != NULL; b = b->GetNext()) {
        
        // check that we have a sprite ref
        if(b->GetUserData() != NULL){
            
            // get the sprite from the body
            Box2DSprite *sprite = (Box2DSprite *) b->GetUserData();
            
            /** 
             we previously updated the sprite as per the body but we don't want to do that. 
             we want to move the sprite and have the body follow.
            sprite.position = ccp(b->GetPosition().x *PTM_RATIO, b->GetPosition().y *PTM_RATIO);            
            sprite.rotation = CC_RADIANS_TO_DEGREES(b->GetAngle() * -1);
            **/
            
            // take the position and angle of the sprite and transform the Box2D body.
            b2Vec2 b2Position = b2Vec2(sprite.position.x/PTM_RATIO, sprite.position.y/PTM_RATIO);
            float32 b2Angle = -1 * CC_DEGREES_TO_RADIANS(sprite.rotation);
            
            b->SetTransform(b2Position, b2Angle);

        } // FOR

        
        // check if player dead
        DogPlayerObject *tempChar = (DogPlayerObject *) [gameSceneSpriteBatchNode getChildByTag:kPlayerTag];
        
        // uses state management
        if (([tempChar objectState] == kStateDead) && ([tempChar numberOfRunningActions] == 0)) {
            
            [[GameManager sharedGameManager] setPlayerDied:YES];
            
            // EVENTUALLY CHANGE SCENES WHEN CHARACTER DIES
//            [[GameManager sharedGameManager] runSceneWithID:kSceneTypeDeath];
//            [self gameOver];
//            [self resetLevel];
//            CCLOG(@"GameplayLayer: player died");
        } 
        
    } // for

    
    /***** COLLISION DETECTION *****/
    
    // assure playerBody isn't null
    assert(playerBody);
    
    // get list of all the contacts that playerBody makes to other bodies
    b2ContactEdge *edge = playerBody->GetContactList();
    
    while(edge)
    {
        // get ref's to fixtures, from contact        
        b2Contact *contact = edge->contact;

        if (contact->IsTouching()){
            
            b2Fixture *fixtureA = contact->GetFixtureA();
            b2Fixture *fixtureB = contact->GetFixtureB();
            
            // get ref's to bodies from fixtures
            
            b2Body *bodyA = fixtureA->GetBody();
            b2Body *bodyB = fixtureB->GetBody();
            
            Box2DSprite *tempSpriteA = (Box2DSprite *) bodyA->GetUserData();
            Box2DSprite *tempSpriteB = (Box2DSprite *) bodyB->GetUserData();
            
            if((tempSpriteA != NULL && [tempSpriteA gameObjectType] == kGameObjTypePowerup) &&
               (tempSpriteB != NULL && [tempSpriteB gameObjectType] == kGameObjTypePlayer)) {
                
                [tempSpriteA changeState:kStateDead];
                CCLOG(@"powerup found");
                
            }else if((tempSpriteB != NULL && [tempSpriteB gameObjectType] == kGameObjTypePowerup) &&
                     (tempSpriteA != NULL && [tempSpriteA gameObjectType] == kGameObjTypePlayer)) {
                
                [tempSpriteB changeState:kStateDead];
                CCLOG(@"powerup found");                    
                
            }else if((tempSpriteA != NULL && [tempSpriteA gameObjectType] == kGameObjTypeEnemy) &&
                     (tempSpriteB != NULL && [tempSpriteB gameObjectType] == kGameObjTypePlayer)){

                // not ideal - enemy objects should have a damage dealt property
                [tempHealthBar setPercentage:[tempHealthBar percentage]*.75f];
                
//                [tempSpriteB changeState:kStateDead];
                CCLOG(@"ENEMY HIT!");
                
            }else if((tempSpriteB != NULL && [tempSpriteB gameObjectType] == kGameObjTypeEnemy) &&
                     (tempSpriteA != NULL && [tempSpriteA gameObjectType] == kGameObjTypePlayer)){
                
                [tempHealthBar setPercentage:[tempHealthBar percentage]*.75f];
                
//                [tempSpriteA changeState:kStateDead];       
                CCLOG(@"ENEMY HIT!");                
            }
            
        } // if contact->IsTouching()
        
        edge = edge->next;
        
    } // while

    
    // after bc the player position needs to update first
    [self scrollLayer];
    
}

-(void)updateHealthbar:(float)newPercentage{
    
    CCLOG(@"GameplayLayer: updating healthbar and player life to: %g", newPercentage);
    
    [playerObject setPlayerLife:newPercentage];
    [tempHealthBar setPercentage:newPercentage];
}


-(void) draw{
    // override default draw method so we can write our own to show debug boxes for Box2D
    glDisable(GL_TEXTURE_2D);
    glDisableClientState(GL_COLOR_ARRAY);
    glDisableClientState(GL_TEXTURE_COORD_ARRAY);
    
    world->DrawDebugData();
    
    glEnable(GL_TEXTURE_2D);
    glEnableClientState(GL_COLOR_ARRAY);
    glEnableClientState(GL_TEXTURE_COORD_ARRAY);
}


# pragma mark -
# pragma mark Scrolling

-(void)scrollLayer{    

    //    DogPlayerObject *playerObject = (DogPlayerObject *) [gameSceneSpriteBatchNode getChildByTag:kPlayerTag];
    CGPoint playerPosition = [playerObject position];
    
    float halfXScreen = screenSize.width/2.0f;
    float halfYScreen = screenSize.height/2.0f;
    
    CGSize levelSize = [[GameManager sharedGameManager] getDimensionsOfCurrentScene];
    
    float newXPosition = playerPosition.x;
    float newYPosition = playerPosition.y;

    // won't scroll background if player is in right-most area of level
    // but will scroll in all other cases
    
    if (playerPosition.x < (levelSize.width - halfXScreen)){
        newXPosition = halfXScreen - playerPosition.x;
    }
    
    if (playerPosition.y < (levelSize.height - halfYScreen)){
        newYPosition = halfYScreen - playerPosition.y;
    }
    
    BackgroundLayer *tempLayer = (BackgroundLayer *)[self.parent getChildByTag:kLayerTagBackground];
    [tempLayer setPosition:ccp(newXPosition, newYPosition)];
    
}


@end




