//
//  PowerupObject.m
//  Boise_Demo
//
//  Created by Jared Halpern on 3/7/12.
//  Copyright 2012 __MyCompanyName__. All rights reserved.
//

#import "PowerupObject.h"


@implementation PowerupObject

@synthesize orbAnim;

-(void)dealloc{
    [orbAnim release];
    
    [super dealloc];
}


-(id)init{
    
    self = [super init];
    if(self != nil){
        
        [self setGameObjectType:kGameObjTypePowerup];
        
        [self initAnimationsForObject];
        
        [self changeState:kStateAlive];
        
    }
    
    return self;
}


-(void)initAnimationsForObject{
    
    // change hardcoding of objectname
    // we'll have more then one enemytype eventually
    
    [self setOrbAnim:[self loadPlistForAnimationWithName:@"orbAnim" 
                                                 andClassName:@"OrbObject"]];
    
}

#pragma mark -
#pragma mark Game Loop

-(void)updateStateWithDeltaTime:(ccTime)deltaTime andListOfGameObjects:(CCArray *)gameObjects{
}    

-(void)changeState:(ObjectStates)newState{
    
    [self stopAllActions];
    [self setObjectState:newState];

    id actionAnim = nil; // we'll fill this with something, depending on the state change
    
    switch (newState) {
            
        case kStateAlive:
        {
            CCLOG(@"PowerupObject: kStateAlive");
            actionAnim = [CCRepeatForever actionWithAction: 
                          [CCAnimate actionWithAnimation:orbAnim restoreOriginalFrame:NO]];

            break;
        }
        case kStateDead:
        {
            CCLOG(@"PowerupObject: kStateDead");
            [self setVisible:NO];
            [self removeFromParentAndCleanup:YES];            

            // use delegate pattern to update player life
            [delegate updateHealthbar:100.0];
            
            // cleanup Box2D
            body->GetWorld()->DestroyBody(body);
            body = NULL;

            break;            
        }
        default:
        {
            CCLOG(@"PowerupObject: unhandled state");
            break;
        }
    }
    
    if (actionAnim != nil)
        [self runAction:actionAnim];
    
}



@end
